/* valacallabletype.c generated by valac, the Vala compiler
 * generated from valacallabletype.vala, do not modify */

/* valacallabletype.vala
 *
 * Copyright (C) 2017  Rico Tzschichholz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Rico Tzschichholz <ricotz@ubuntu.com>
 */

#include "vala.h"
#include <glib.h>
#include <valagee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

static gpointer vala_callable_type_parent_class = NULL;

static gboolean vala_callable_type_real_is_invokable (ValaDataType* base);
static ValaDataType* vala_callable_type_real_get_return_type (ValaDataType* base);
static ValaList* vala_callable_type_real_get_parameters (ValaDataType* base);
static gchar* vala_callable_type_real_to_prototype_string (ValaDataType* base,
                                                    const gchar* override_name);
static GType vala_callable_type_get_type_once (void);

ValaCallable*
vala_callable_type_get_callable_symbol (ValaCallableType* self)
{
	ValaCallable* result;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = vala_data_type_get_symbol ((ValaDataType*) self);
	_tmp1_ = _tmp0_;
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, VALA_TYPE_CALLABLE, ValaCallable);
	return result;
}

ValaCallableType*
vala_callable_type_construct (GType object_type,
                              ValaSymbol* symbol)
{
	ValaCallableType* self = NULL;
	g_return_val_if_fail (symbol != NULL, NULL);
	self = (ValaCallableType*) vala_data_type_construct_with_symbol (object_type, symbol);
	return self;
}

static gboolean
vala_callable_type_real_is_invokable (ValaDataType* base)
{
	ValaCallableType * self;
	gboolean result = FALSE;
	self = (ValaCallableType*) base;
	result = TRUE;
	return result;
}

static ValaDataType*
vala_callable_type_real_get_return_type (ValaDataType* base)
{
	ValaCallableType * self;
	ValaCallable* _tmp0_;
	ValaCallable* _tmp1_;
	ValaDataType* _tmp2_;
	ValaDataType* _tmp3_;
	ValaDataType* result = NULL;
	self = (ValaCallableType*) base;
	_tmp0_ = vala_callable_type_get_callable_symbol (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_callable_get_return_type (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_;
	return result;
}

static ValaList*
vala_callable_type_real_get_parameters (ValaDataType* base)
{
	ValaCallableType * self;
	ValaCallable* _tmp0_;
	ValaCallable* _tmp1_;
	ValaList* _tmp2_;
	ValaList* result = NULL;
	self = (ValaCallableType*) base;
	_tmp0_ = vala_callable_type_get_callable_symbol (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_callable_get_parameters (_tmp1_);
	result = _tmp2_;
	return result;
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static gchar*
vala_callable_type_real_to_prototype_string (ValaDataType* base,
                                             const gchar* override_name)
{
	ValaCallableType * self;
	GString* builder = NULL;
	GString* _tmp0_;
	ValaDataType* return_type = NULL;
	ValaDataType* _tmp1_;
	ValaDataType* _tmp2_;
	GString* _tmp4_;
	ValaDataType* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GString* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	GString* _tmp12_;
	GString* _tmp13_;
	GString* _tmp14_;
	gint i = 0;
	ValaDelegateType* delegate_type = NULL;
	ValaDelegateType* _tmp15_;
	GString* _tmp95_;
	ValaArrayList* error_types = NULL;
	GEqualFunc _tmp96_;
	ValaArrayList* _tmp97_;
	ValaArrayList* _tmp98_;
	ValaArrayList* _tmp99_;
	gint _tmp100_;
	gint _tmp101_;
	GString* _tmp117_;
	const gchar* _tmp118_;
	gchar* _tmp119_;
	gchar* result = NULL;
	self = (ValaCallableType*) base;
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	_tmp1_ = vala_data_type_get_return_type ((ValaDataType*) self);
	return_type = _tmp1_;
	_tmp2_ = return_type;
	if (vala_data_type_is_weak (_tmp2_)) {
		GString* _tmp3_;
		_tmp3_ = builder;
		g_string_append (_tmp3_, "unowned ");
	}
	_tmp4_ = builder;
	_tmp5_ = return_type;
	_tmp6_ = vala_data_type_to_qualified_string (_tmp5_, NULL);
	_tmp7_ = _tmp6_;
	g_string_append (_tmp4_, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = builder;
	g_string_append_c (_tmp8_, ' ');
	_tmp10_ = g_strdup (override_name);
	_tmp9_ = _tmp10_;
	if (_tmp9_ == NULL) {
		gchar* _tmp11_;
		_tmp11_ = vala_code_node_to_string ((ValaCodeNode*) self);
		_g_free0 (_tmp9_);
		_tmp9_ = _tmp11_;
	}
	_tmp12_ = builder;
	g_string_append (_tmp12_, _tmp9_);
	_tmp13_ = builder;
	g_string_append_c (_tmp13_, ' ');
	_tmp14_ = builder;
	g_string_append_c (_tmp14_, '(');
	i = 1;
	delegate_type = VALA_IS_DELEGATE_TYPE (self) ? ((ValaDelegateType*) self) : NULL;
	_tmp15_ = delegate_type;
	if (_tmp15_ != NULL) {
		ValaDelegate* delegate_symbol = NULL;
		ValaDelegateType* _tmp16_;
		ValaDelegate* _tmp17_;
		ValaDelegate* _tmp18_;
		gboolean _tmp19_ = FALSE;
		ValaDelegate* _tmp20_;
		ValaSymbol* _tmp21_;
		ValaSymbol* _tmp22_;
		_tmp16_ = delegate_type;
		_tmp17_ = vala_delegate_type_get_delegate_symbol (_tmp16_);
		_tmp18_ = _tmp17_;
		delegate_symbol = _tmp18_;
		_tmp20_ = delegate_symbol;
		_tmp21_ = vala_symbol_get_parent_symbol ((ValaSymbol*) _tmp20_);
		_tmp22_ = _tmp21_;
		if (VALA_IS_SIGNAL (_tmp22_)) {
			ValaDelegate* _tmp23_;
			ValaDataType* _tmp24_;
			ValaDataType* _tmp25_;
			_tmp23_ = delegate_symbol;
			_tmp24_ = vala_delegate_get_sender_type (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp19_ = _tmp25_ != NULL;
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			GString* _tmp26_;
			ValaDelegate* _tmp27_;
			ValaDataType* _tmp28_;
			ValaDataType* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gint _tmp32_;
			_tmp26_ = builder;
			_tmp27_ = delegate_symbol;
			_tmp28_ = vala_delegate_get_sender_type (_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = vala_data_type_to_qualified_string (_tmp29_, NULL);
			_tmp31_ = _tmp30_;
			g_string_append (_tmp26_, _tmp31_);
			_g_free0 (_tmp31_);
			_tmp32_ = i;
			i = _tmp32_ + 1;
		}
	}
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp33_;
		ValaList* _tmp34_;
		gint _param_size = 0;
		ValaList* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		gint _param_index = 0;
		_tmp33_ = vala_data_type_get_parameters ((ValaDataType*) self);
		_tmp34_ = _vala_iterable_ref0 (_tmp33_);
		_param_list = _tmp34_;
		_tmp35_ = _param_list;
		_tmp36_ = vala_collection_get_size ((ValaCollection*) _tmp35_);
		_tmp37_ = _tmp36_;
		_param_size = _tmp37_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp38_;
			gint _tmp39_;
			ValaParameter* param = NULL;
			ValaList* _tmp40_;
			gpointer _tmp41_;
			ValaParameter* _tmp43_;
			gboolean _tmp44_;
			gboolean _tmp45_;
			ValaParameter* _tmp47_;
			gboolean _tmp48_;
			gboolean _tmp49_;
			ValaParameter* _tmp51_;
			ValaParameterDirection _tmp52_;
			ValaParameterDirection _tmp53_;
			GString* _tmp78_;
			ValaParameter* _tmp79_;
			ValaDataType* _tmp80_;
			ValaDataType* _tmp81_;
			gchar* _tmp82_;
			gchar* _tmp83_;
			ValaParameter* _tmp84_;
			ValaExpression* _tmp85_;
			ValaExpression* _tmp86_;
			gint _tmp94_;
			_param_index = _param_index + 1;
			_tmp38_ = _param_index;
			_tmp39_ = _param_size;
			if (!(_tmp38_ < _tmp39_)) {
				break;
			}
			_tmp40_ = _param_list;
			_tmp41_ = vala_list_get (_tmp40_, _param_index);
			param = (ValaParameter*) _tmp41_;
			if (i > 1) {
				GString* _tmp42_;
				_tmp42_ = builder;
				g_string_append (_tmp42_, ", ");
			}
			_tmp43_ = param;
			_tmp44_ = vala_parameter_get_ellipsis (_tmp43_);
			_tmp45_ = _tmp44_;
			if (_tmp45_) {
				GString* _tmp46_;
				_tmp46_ = builder;
				g_string_append (_tmp46_, "...");
				_vala_code_node_unref0 (param);
				continue;
			}
			_tmp47_ = param;
			_tmp48_ = vala_parameter_get_params_array (_tmp47_);
			_tmp49_ = _tmp48_;
			if (_tmp49_) {
				GString* _tmp50_;
				_tmp50_ = builder;
				g_string_append (_tmp50_, "params ");
			}
			_tmp51_ = param;
			_tmp52_ = vala_parameter_get_direction (_tmp51_);
			_tmp53_ = _tmp52_;
			if (_tmp53_ == VALA_PARAMETER_DIRECTION_IN) {
				ValaParameter* _tmp54_;
				ValaDataType* _tmp55_;
				ValaDataType* _tmp56_;
				gboolean _tmp57_;
				gboolean _tmp58_;
				_tmp54_ = param;
				_tmp55_ = vala_variable_get_variable_type ((ValaVariable*) _tmp54_);
				_tmp56_ = _tmp55_;
				_tmp57_ = vala_data_type_get_value_owned (_tmp56_);
				_tmp58_ = _tmp57_;
				if (_tmp58_) {
					GString* _tmp59_;
					_tmp59_ = builder;
					g_string_append (_tmp59_, "owned ");
				}
			} else {
				ValaParameter* _tmp60_;
				ValaParameterDirection _tmp61_;
				ValaParameterDirection _tmp62_;
				gboolean _tmp68_ = FALSE;
				ValaParameter* _tmp69_;
				ValaDataType* _tmp70_;
				ValaDataType* _tmp71_;
				gboolean _tmp72_;
				gboolean _tmp73_;
				_tmp60_ = param;
				_tmp61_ = vala_parameter_get_direction (_tmp60_);
				_tmp62_ = _tmp61_;
				if (_tmp62_ == VALA_PARAMETER_DIRECTION_REF) {
					GString* _tmp63_;
					_tmp63_ = builder;
					g_string_append (_tmp63_, "ref ");
				} else {
					ValaParameter* _tmp64_;
					ValaParameterDirection _tmp65_;
					ValaParameterDirection _tmp66_;
					_tmp64_ = param;
					_tmp65_ = vala_parameter_get_direction (_tmp64_);
					_tmp66_ = _tmp65_;
					if (_tmp66_ == VALA_PARAMETER_DIRECTION_OUT) {
						GString* _tmp67_;
						_tmp67_ = builder;
						g_string_append (_tmp67_, "out ");
					}
				}
				_tmp69_ = param;
				_tmp70_ = vala_variable_get_variable_type ((ValaVariable*) _tmp69_);
				_tmp71_ = _tmp70_;
				_tmp72_ = vala_data_type_get_value_owned (_tmp71_);
				_tmp73_ = _tmp72_;
				if (!_tmp73_) {
					ValaParameter* _tmp74_;
					ValaDataType* _tmp75_;
					ValaDataType* _tmp76_;
					_tmp74_ = param;
					_tmp75_ = vala_variable_get_variable_type ((ValaVariable*) _tmp74_);
					_tmp76_ = _tmp75_;
					_tmp68_ = VALA_IS_REFERENCE_TYPE (_tmp76_);
				} else {
					_tmp68_ = FALSE;
				}
				if (_tmp68_) {
					GString* _tmp77_;
					_tmp77_ = builder;
					g_string_append (_tmp77_, "weak ");
				}
			}
			_tmp78_ = builder;
			_tmp79_ = param;
			_tmp80_ = vala_variable_get_variable_type ((ValaVariable*) _tmp79_);
			_tmp81_ = _tmp80_;
			_tmp82_ = vala_data_type_to_qualified_string (_tmp81_, NULL);
			_tmp83_ = _tmp82_;
			g_string_append (_tmp78_, _tmp83_);
			_g_free0 (_tmp83_);
			_tmp84_ = param;
			_tmp85_ = vala_variable_get_initializer ((ValaVariable*) _tmp84_);
			_tmp86_ = _tmp85_;
			if (_tmp86_ != NULL) {
				GString* _tmp87_;
				GString* _tmp88_;
				ValaParameter* _tmp89_;
				ValaExpression* _tmp90_;
				ValaExpression* _tmp91_;
				gchar* _tmp92_;
				gchar* _tmp93_;
				_tmp87_ = builder;
				g_string_append (_tmp87_, " = ");
				_tmp88_ = builder;
				_tmp89_ = param;
				_tmp90_ = vala_variable_get_initializer ((ValaVariable*) _tmp89_);
				_tmp91_ = _tmp90_;
				_tmp92_ = vala_code_node_to_string ((ValaCodeNode*) _tmp91_);
				_tmp93_ = _tmp92_;
				g_string_append (_tmp88_, _tmp93_);
				_g_free0 (_tmp93_);
			}
			_tmp94_ = i;
			i = _tmp94_ + 1;
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	_tmp95_ = builder;
	g_string_append_c (_tmp95_, ')');
	_tmp96_ = g_direct_equal;
	_tmp97_ = vala_array_list_new (VALA_TYPE_DATA_TYPE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp96_);
	error_types = _tmp97_;
	_tmp98_ = error_types;
	vala_code_node_get_error_types ((ValaCodeNode*) self, (ValaCollection*) _tmp98_, NULL);
	_tmp99_ = error_types;
	_tmp100_ = vala_collection_get_size ((ValaCollection*) _tmp99_);
	_tmp101_ = _tmp100_;
	if (_tmp101_ > 0) {
		GString* _tmp102_;
		gboolean first = FALSE;
		_tmp102_ = builder;
		g_string_append (_tmp102_, " throws ");
		first = TRUE;
		{
			ValaArrayList* _type_list = NULL;
			ValaArrayList* _tmp103_;
			ValaArrayList* _tmp104_;
			gint _type_size = 0;
			ValaArrayList* _tmp105_;
			gint _tmp106_;
			gint _tmp107_;
			gint _type_index = 0;
			_tmp103_ = error_types;
			_tmp104_ = _vala_iterable_ref0 (_tmp103_);
			_type_list = _tmp104_;
			_tmp105_ = _type_list;
			_tmp106_ = vala_collection_get_size ((ValaCollection*) _tmp105_);
			_tmp107_ = _tmp106_;
			_type_size = _tmp107_;
			_type_index = -1;
			while (TRUE) {
				gint _tmp108_;
				gint _tmp109_;
				ValaDataType* type = NULL;
				ValaArrayList* _tmp110_;
				gpointer _tmp111_;
				GString* _tmp113_;
				ValaDataType* _tmp114_;
				gchar* _tmp115_;
				gchar* _tmp116_;
				_type_index = _type_index + 1;
				_tmp108_ = _type_index;
				_tmp109_ = _type_size;
				if (!(_tmp108_ < _tmp109_)) {
					break;
				}
				_tmp110_ = _type_list;
				_tmp111_ = vala_list_get ((ValaList*) _tmp110_, _type_index);
				type = (ValaDataType*) _tmp111_;
				if (!first) {
					GString* _tmp112_;
					_tmp112_ = builder;
					g_string_append (_tmp112_, ", ");
				} else {
					first = FALSE;
				}
				_tmp113_ = builder;
				_tmp114_ = type;
				_tmp115_ = vala_code_node_to_string ((ValaCodeNode*) _tmp114_);
				_tmp116_ = _tmp115_;
				g_string_append (_tmp113_, _tmp116_);
				_g_free0 (_tmp116_);
				_vala_code_node_unref0 (type);
			}
			_vala_iterable_unref0 (_type_list);
		}
	}
	_tmp117_ = builder;
	_tmp118_ = _tmp117_->str;
	_tmp119_ = g_strdup (_tmp118_);
	result = _tmp119_;
	_vala_iterable_unref0 (error_types);
	_g_free0 (_tmp9_);
	_g_string_free0 (builder);
	return result;
}

static void
vala_callable_type_class_init (ValaCallableTypeClass * klass,
                               gpointer klass_data)
{
	vala_callable_type_parent_class = g_type_class_peek_parent (klass);
	((ValaDataTypeClass *) klass)->is_invokable = (gboolean (*) (ValaDataType*)) vala_callable_type_real_is_invokable;
	((ValaDataTypeClass *) klass)->get_return_type = (ValaDataType* (*) (ValaDataType*)) vala_callable_type_real_get_return_type;
	((ValaDataTypeClass *) klass)->get_parameters = (ValaList* (*) (ValaDataType*)) vala_callable_type_real_get_parameters;
	((ValaDataTypeClass *) klass)->to_prototype_string = (gchar* (*) (ValaDataType*, const gchar*)) vala_callable_type_real_to_prototype_string;
}

static void
vala_callable_type_instance_init (ValaCallableType * self,
                                  gpointer klass)
{
}

/**
 * A callable type, i.e. a delegate, method, or signal type.
 */
static GType
vala_callable_type_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaCallableTypeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_callable_type_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCallableType), 0, (GInstanceInitFunc) vala_callable_type_instance_init, NULL };
	GType vala_callable_type_type_id;
	vala_callable_type_type_id = g_type_register_static (VALA_TYPE_DATA_TYPE, "ValaCallableType", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return vala_callable_type_type_id;
}

GType
vala_callable_type_get_type (void)
{
	static volatile gsize vala_callable_type_type_id__volatile = 0;
	if (g_once_init_enter (&vala_callable_type_type_id__volatile)) {
		GType vala_callable_type_type_id;
		vala_callable_type_type_id = vala_callable_type_get_type_once ();
		g_once_init_leave (&vala_callable_type_type_id__volatile, vala_callable_type_type_id);
	}
	return vala_callable_type_type_id__volatile;
}

